// Dominique Jacquel - Mech. Eng. - University of Edinburgh

#import "MadsObserverSwarm.h"
#import "myAgent.h"
#import <simtoolsgui.h>
#import <misc.h>

@implementation MadsObserverSwarm

+ createBegin: aZone {
  MadsObserverSwarm * obj = [super createBegin: aZone];
  id <ProbeMap> mainProbe;

  // MODIFY: initialize other display options here.
  obj->displayFrequency = 500;

  mainProbe = [EmptyProbeMap createBegin: aZone];
  [mainProbe setProbedClass: [self class]];
  mainProbe = [mainProbe createEnd];
  [mainProbe addProbe: [probeLibrary getProbeForMessage: "createAgent" inClass: [self class]]];
  [mainProbe addProbe: [probeLibrary getProbeForMessage: "testDragnDrop::" inClass: [self class]]];
  [probeLibrary setProbeMap: mainProbe For: [self class]];

  return obj;
}

// MODIFY: possible creation finalization here
- createEnd {
  // initialize unique name genrator
  nameGenerator = [UName create: [self getZone] setBaseName: "Agent"];
  return [super createEnd];
}

- buildObjects {
  id modelZone;

  [super buildObjects];

  // create the facilitator
  modelZone = [Zone create: [self getZone]];
  [actionCache waitForControlEvent];
  if ([controlPanel getState] == ControlStateQuit) return self;
  CREATE_ARCHIVED_PROBE_DISPLAY (self);    
  return self;
}  

-buildActions {
  [super buildActions];
  
  // MODIFY: schedule display objects here
  displayActions = [ActionGroup create: [self getZone]];
  [displayActions createActionTo: probeDisplayManager message: M(update)];
  [displayActions createActionTo: actionCache         message: M(doTkEvents)];
  displaySchedule = [Schedule createBegin: [self getZone]];
  [displaySchedule setRepeatInterval: displayFrequency];
  displaySchedule = [displaySchedule createEnd];
  [displaySchedule at: 0 createAction: displayActions];

  return self;
}  

- activateIn: swarmContext {
  [super activateIn: swarmContext];
  [displaySchedule activateIn: self];  
  return [self getSwarmActivity];
}

- _update_ {
  return self;
}

// global feature creation function
- createAgent {
  id agent;
  agent = [myAgent create:[self getZone]];
  return agent;
}

- (BOOL)testDragnDrop:(id)A :(id)B {
  if (A==B) {
    fprintf(stderr,"\n A and B are identical! --> therefor DnD is BUGGY!");
    fflush(stderr);
    return NO;
  }
  else { 
    fprintf(stderr,"\n It is working --> are you running NT??");
    fflush(stderr);
    return YES;
  }
}


@end
